#!/bin/bash
#
# Genera un instalador MakeSelf de FierroUtils.
# Lambda Soluciones. Mar, 2006.
#
#


function die {
	echo $1 >&2
	if [ -z $2 ]; then
		exit 1
	else
		exit $2
	fi
}

if [ $# -lt 2 ]; then
	die "Usage: $0 <workpath> <version> [<user> <password>] [<svn-revision>]" 2
fi

CURRDIR=$PWD
WORKPATH=$1
VERSION=$2
USER=$3
PASSWORD=$4
if [ -z $URL ]; then
	URL=$PWD/..
fi
if [ -z $DSTDIR ]; then
	DSTDIR=$CURRDIR
fi
if [ $5 ]; then
	REVISION="-r $5"
fi

TARGETFILENAME=queueServer-$VERSION
if [ ! -z $CUSTOMER ]; then
	TARGETFILENAME=$TARGETFILENAME-$CUSTOMER
fi

WORKDIR=$WORKPATH/queueServer-$VERSION-workdir

if [ -e $WORKDIR ]; then
	rm -fR $WORKDIR
fi
mkdir -p $WORKPATH
svn export $REVISION $URL --username $USER --password $PASSWORD $WORKDIR
# Hago modificaciones a la version estandar
if [ ! -z $CUSTOMER ]; then
	echo "Haciendo modificaciones para el cliente $CUSTOMER"
	cd $WORKDIR
	# Primero reemplazo los archivos .$CUSTOMER
	echo "Reemplazos"
	for i in `find . -name "*.$CUSTOMER"`; do 
		mv $i ${i%%.$CUSTOMER}
	done
	echo "Parches"
	for i in `find . -name "*.$CUSTOMER.patch"`; do 
		patch ${i%%.$CUSTOMER.patch} $i
	done
fi

cd $WORKDIR
mkdir $TARGETFILENAME
echo "Copiando /bin"
cp queueServer.py setup.py $TARGETFILENAME/
cp queueServer.conf.sample $TARGETFILENAME/queueServer.conf
cp queueServer $TARGETFILENAME/
tar -zcf $TARGETFILENAME.tar.gz $TARGETFILENAME
mkdir pkg
mv $TARGETFILENAME.tar.gz pkg
sed "s/%%VERSION%%/$VERSION/g" installer/install.sh.template | \
	sed "s/%%PACKAGE%%/queueServer/g" >pkg/install.sh
chmod u+x pkg/install.sh
cp installer/queueServer.ebuild pkg/$TARGETFILENAME.ebuild
makeself.sh --nocomp pkg $TARGETFILENAME.run "QueueServer v$VERSION" ./install.sh
mv $TARGETFILENAME.run $DSTDIR
if [ -z $KEEPWORKDIR ]; then
	rm -fR $WORKDIR
fi
